Request

Response

    Assigned Structures
    POST

    projects/{projectId}/assigned-structures:batch-add

    Assigns one or more classification structures (trees) to a Takeoff project. A project can have a maximum of five assigned structures.

    Classification structures are defined in the Classifications API. To retrieve the classification structures available in the project, call GET trees. To create a classification structure, call POST trees:import.

    To retrieve the structures currently assigned to the Takeoff project, call GET assigned-structures.

    For more information about classifications in Takeoff, see the Configure Takeoff Settings documentation.

    Note that this endpoint is not compatible with BIM 360 projects.

    Resource Information

    Method and URI
    POST
    https://developer.api.autodesk.com/construction/takeoff/v1/projects/{projectId}/assigned-structures:batch-add
    Authentication Context
    User context required
    Required OAuth Scopes
    data:write
    Data Format
    JSON

    Request

    Headers

    Authorization*
    string
    Must be Bearer <token>, where <token> is a three-legged access token obtained via an Authorization Code flow or a Secure Service Account (SSA) flow.

    The SSA flow is designed for headless server-to-server operations. While it functions like a two-legged flow (no user interaction), it is classified as three-legged because it preserves user context.

    region
    string
    Specifies the region where the service is located.

    Possible values: US, EMEA. For the full list of supported regions, see the Regions page.

    Content-Type*
    string
    Must be application/json
    * Required

    Request

    URI Parameters

    projectId
    string: UUID
    The ID of the project.

    This corresponds to project ID in the Data Management API, and can be specified in the form of “UUID” or b.”UUID”.

    To learn how to find the project ID, see the Retrieve Forma hub and project ID tutorial.

    Request

    Body Structure

    The payload for adding project assigned structures.

    structureId*
    string: UUID
    The ID of the classification structure (tree). Classification trees are defined in the Classifications API. Use the value of the id field returned by GET trees/{treeId}.
    * Required

    Response

    HTTP Status Code Summary

    201
    Created
    Successfully added the project assigned structures.
    400
    Bad Request
    The parameters of the requested operation are invalid.
    401
    Unauthorized
    The provided bearer token is not valid.
    403
    Forbidden
    The user or service represented by the bearer token does not have permission to perform this operation.
    404
    Not Found
    The requested resource could not be found.
    409
    Conflict
    One or more of the project assigned structures may already exist.
    429
    Too Many Requests
    Rate limit exceeded; wait some time before retrying. The ‘Retry-After’ header might provide the amount of the time to wait.
    500
    Internal Server Error
    An unknown error occurred on the server.

    Response

    Body Structure (201)

    Expand all
    results
    array: object
    The list of classification structures that were added to the project.
    structureId
    string: UUID
    The ID of the classification structure (tree). Classification trees are defined in the Classifications API. Use the value of the id field returned by GET trees/{treeId}.
    createdAt
    datetime: ISO 8601
    The date and time when the assigned structure was added to the project, in the following format: YYYY-MM-DDThh:mm:ssZ.
    createdBy
    string
    The Autodesk ID of the user who added the assigned structure to the project. To find details about the user call GET users.

    Example

    Successfully added the project assigned structures.

    Request

    curl -v 'https://developer.api.autodesk.com/construction/takeoff/v1/projects/:projectId/assigned-structures:batch-add' \
      -X 'POST' \
      -H 'Authorization: Bearer AuIPTf4KYLTYGVnOHQ0cuolwCW2a' \
      -H 'Content-Type: application/json' \
      -d '[
            {
              "structureId": "4d5a4fd0-0fb8-11ed-aef7-0242ac120002"
            }
          ]'
    
    Show More

    Response

    {
      "results": [
        {
          "structureId": "4d5a4fd0-0fb8-11ed-aef7-0242ac120002",
          "createdAt": "2019-11-20T10:42:54.304Z",
          "createdBy": "Z56MMDCCC6YA"
        }
      ]
    }
    
    Show More